;Casovas 0-9min nastaveno 8min
;Rizeni vnitrnim oscilatorem

	LIST P=16F628, R=DEC
	INCLUDE<P16F628.INC>
	__CONFIG 0x3D10

W		EQU	0	;nastaveno pro umisteni vysledku
F		EQU	1	;operaci
OFFRAM	EQU	20h	;zacatek volne pameti procesoru

;--------promene------------------------			
W_SAVE	EQU	OFFRAM
STA_SAV	EQU	OFFRAM+1
FSR_SAV	EQU	OFFRAM+2
SEC		EQU	OFFRAM+3	;sekundy
MIN		EQU	OFFRAM+4	;minuty
POM1	EQU	OFFRAM+5	;pomocny 1
PSW		EQU	OFFRAM+6	;registr priznaku

;--------definice----------------------
#DEFINE	TLAC1	PORTB,0	;start odpocet 
#DEFINE	TLAC2	PORTB,1	;stop odpocet
#DEFINE	LED		PORTB,2	;indikace odpoctu
#DEFINE	ZATEZ	PORTB,3	;vystupni rele
#DEFINE	ZTL1	PSW,1	;start odpoctu
#DEFINE	ZTL2	PSW,2	;stop odpoctu
#DEFINE	ZNOVU	PSW,3	;priprava na novy odpocet
	
	ORG	00h
	GOTO	START

	ORG	04h
	MOVWF	W_SAVE		;W zaloha
	SWAPF	STATUS,W	;status zaloha
	MOVWF	STA_SAV
	SWAPF	FSR,W
	MOVWF	FSR_SAV		;FSR zaloha
	GOTO	PRERUS

;----------pomocne programy-------------

;----------kontrola stavu tlacitka------
TLA1
	BTFSS	TLAC1	;Kontrola stavu tlacitka
	GOTO	TL1
	BCF		ZTL1	;neni stisknute
	RETURN
	
TL1
	BTFSC	ZTL1	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		ZTL1	;nastaveni priznaku tlacitka
	RETURN

TLA2
	BTFSS	TLAC2	;Kontrola stavu tlacitka
	GOTO	TL2
	BCF		ZTL2	;neni stisknute
	RETURN
	
TL2
	BTFSC	ZTL2	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		ZTL2	;nastaveni priznaku tlacitka
	RETURN
;------------zobrazovani cislic------------
TAB1					;Prekodovani znaku
	ADDWF	PCL,F		;Pricte W k citaci instrukci
	RETLW	B'10100000'	;Zobrazi 0
	RETLW	B'11111001'	;Zobrazi 1
	RETLW	B'01100100'	;Zobrazi 2
	RETLW	B'01110000'	;Zobrazi 3
	RETLW	B'00111001'	;Zobrazi 4
	RETLW	B'00110010'	;Zobrazi 5
	RETLW	B'00100010'	;Zobrazi 6
	RETLW	B'11111000'	;Zobrazi 7
	RETLW	B'00100000'	;Zobrazi 8
	RETLW	B'00110000'	;Zobrazi 9
;*****************************************************

START	
	CLRF	PORTA
	MOVLW	07h			;Vypnuti komparatoru
	MOVWF	CMCON		;PortA I/O
	BCF		STATUS,RP1
	BSF		STATUS,RP0	;zakladni nastaveni
	MOVLW	B'00100000'
	MOVWF	TRISA
	MOVLW	B'00000011'
	MOVWF	TRISB
	MOVLW	B'01010011'	;nastaveni option preddelicka 1:16
	MOVWF	OPTION_REG
	BCF		STATUS,RP0

SSET
	BSF		ZATEZ
	BSF		LED
	MOVLW	60
	MOVWF	SEC
	MOVLW	9
	MOVWF	MIN
	CALL	TAB1
	MOVWF	PORTA
	CLRF	PSW

MAIN
	BTFSC	ZNOVU		;kontrola na novy odpocet
	GOTO	SSET
	CALL	TLA1
	BTFSS	ZTL1		;kontrola stisku tlacitka
	GOTO	MAIN
	MOVLW	255
	MOVWF	POM1
	MOVLW	B'10100000'	;nastaveni moznosti preruseni
	MOVWF	INTCON
MA1
	CALL	TLA2
	BTFSS	ZTL2		;kontrola stisku tlacitka
	GOTO	MA1
	MOVLW	B'00000000'	;nastaveni moznosti preruseni
	MOVWF	INTCON
	GOTO	MAIN
	
PRERUS
	DECFSZ	POM1,F
	GOTO	PEND
	DECFSZ	SEC,F
	GOTO	$+2
	GOTO	DMIN
	BTFSS	LED
	GOTO	$+3
	BCF		LED
	GOTO	$+2
	BSF		LED
	GOTO	PEND
DMIN
	DECFSZ	MIN,F
	MOVLW	60
	MOVWF	SEC
	MOVF	MIN,F
	BTFSS	STATUS,Z	;konec odpoctu
	GOTO	PEND
	BCF		ZATEZ
	MOVLW	B'00000000'	;nastaveni moznosti preruseni
	MOVWF	INTCON
	MOVLW	B'11111111'		;zhasni display
	MOVWF	PORTA
	BSF		ZNOVU
	GOTO	PEND2

PEND
	MOVF	MIN,W		;zobrazi minuty na display
	CALL	TAB1
	MOVWF	PORTA
	MOVLW	4			;zakladni nastaveni TMR0
	MOVWF	TMR0
	MOVLW	B'00100000'	;nastaveni moznosti preruseni
	MOVWF	INTCON

PEND2
	SWAPF	FSR_SAV,W
	MOVWF	FSR
	SWAPF	STA_SAV,W
	MOVWF	STATUS
	SWAPF	W_SAVE,F
	SWAPF	W_SAVE,W
	RETFIE

	END
